Index: trunk/l10n/tspsg_uk.ts
===================================================================
--- trunk/i18n/tspsg_uk.ts	(revision 94)
+++ trunk/l10n/tspsg_uk.ts	(revision 96)
@@ -6,5 +6,5 @@
     <name>--------</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="600"/>
+        <location filename="../src/mainwindow.cpp" line="616"/>
         <source>LANGNAME</source>
         <comment>Please, provide a native name of your translation language here.</comment>
@@ -25,10 +25,10 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="356"/>
+        <location filename="../src/tspmodel.cpp" line="365"/>
         <source>Unexpected end of file.</source>
         <translation>Неочікуваний кінець файлу.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="358"/>
+        <location filename="../src/tspmodel.cpp" line="367"/>
         <source>Corrupt data read. File possibly corrupted.</source>
         <translation>Прочитано ушкоджені дані.
@@ -36,5 +36,5 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="360"/>
+        <location filename="../src/tspmodel.cpp" line="369"/>
         <source>Unknown error.</source>
         <translation>Невідома помилка.</translation>
@@ -43,9 +43,9 @@
         <location filename="../src/tspmodel.cpp" line="141"/>
         <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="362"/>
-        <location filename="../src/tspmodel.cpp" line="379"/>
-        <location filename="../src/tspmodel.cpp" line="393"/>
-        <location filename="../src/tspmodel.cpp" line="431"/>
-        <location filename="../src/tspmodel.cpp" line="441"/>
+        <location filename="../src/tspmodel.cpp" line="371"/>
+        <location filename="../src/tspmodel.cpp" line="388"/>
+        <location filename="../src/tspmodel.cpp" line="402"/>
+        <location filename="../src/tspmodel.cpp" line="440"/>
+        <location filename="../src/tspmodel.cpp" line="450"/>
         <source>Task Load</source>
         <translation>Завантаження умови</translation>
@@ -53,9 +53,9 @@
     <message>
         <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="362"/>
-        <location filename="../src/tspmodel.cpp" line="379"/>
-        <location filename="../src/tspmodel.cpp" line="393"/>
-        <location filename="../src/tspmodel.cpp" line="431"/>
-        <location filename="../src/tspmodel.cpp" line="441"/>
+        <location filename="../src/tspmodel.cpp" line="371"/>
+        <location filename="../src/tspmodel.cpp" line="388"/>
+        <location filename="../src/tspmodel.cpp" line="402"/>
+        <location filename="../src/tspmodel.cpp" line="440"/>
+        <location filename="../src/tspmodel.cpp" line="450"/>
         <source>Unable to load task:</source>
         <translation>Неможливо завантажити умову:</translation>
@@ -74,6 +74,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="379"/>
-        <location filename="../src/tspmodel.cpp" line="431"/>
+        <location filename="../src/tspmodel.cpp" line="388"/>
+        <location filename="../src/tspmodel.cpp" line="440"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -82,6 +82,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="393"/>
-        <location filename="../src/tspmodel.cpp" line="441"/>
+        <location filename="../src/tspmodel.cpp" line="402"/>
+        <location filename="../src/tspmodel.cpp" line="450"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -90,17 +90,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="228"/>
-        <location filename="../src/tspmodel.cpp" line="236"/>
-        <location filename="../src/tspmodel.cpp" line="244"/>
-        <location filename="../src/tspmodel.cpp" line="252"/>
-        <location filename="../src/tspmodel.cpp" line="260"/>
-        <location filename="../src/tspmodel.cpp" line="268"/>
-        <location filename="../src/tspmodel.cpp" line="276"/>
-        <location filename="../src/tspmodel.cpp" line="287"/>
+        <location filename="../src/tspmodel.cpp" line="234"/>
+        <location filename="../src/tspmodel.cpp" line="242"/>
+        <location filename="../src/tspmodel.cpp" line="250"/>
+        <location filename="../src/tspmodel.cpp" line="258"/>
+        <location filename="../src/tspmodel.cpp" line="266"/>
+        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="282"/>
+        <location filename="../src/tspmodel.cpp" line="293"/>
         <source>Task Save</source>
         <translation>Збереження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="228"/>
+        <location filename="../src/tspmodel.cpp" line="234"/>
         <source>Unable to create task file.
 Error: %1
@@ -111,11 +111,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="236"/>
-        <location filename="../src/tspmodel.cpp" line="244"/>
-        <location filename="../src/tspmodel.cpp" line="252"/>
-        <location filename="../src/tspmodel.cpp" line="260"/>
-        <location filename="../src/tspmodel.cpp" line="268"/>
-        <location filename="../src/tspmodel.cpp" line="276"/>
-        <location filename="../src/tspmodel.cpp" line="287"/>
+        <location filename="../src/tspmodel.cpp" line="242"/>
+        <location filename="../src/tspmodel.cpp" line="250"/>
+        <location filename="../src/tspmodel.cpp" line="258"/>
+        <location filename="../src/tspmodel.cpp" line="266"/>
+        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="282"/>
+        <location filename="../src/tspmodel.cpp" line="293"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -164,171 +164,171 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../ui/mainwindow.ui" line="58"/>
+        <location filename="../ui/mainwindow.ui" line="61"/>
         <source>Number of variant</source>
         <translation>Номер варіанту</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="81"/>
+        <location filename="../ui/mainwindow.ui" line="84"/>
         <source>Number of cities</source>
         <translation>Кількість міст, що проходить комівояжер</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="267"/>
+        <location filename="../ui/mainwindow.ui" line="270"/>
         <source>Save &amp;As</source>
         <translation>Зберегти &amp;як</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="289"/>
+        <location filename="../ui/mainwindow.ui" line="292"/>
         <source>Select language</source>
         <translation>Вибір мови</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="292"/>
+        <location filename="../ui/mainwindow.ui" line="295"/>
         <source>Select application language</source>
         <translation>Обрати мову додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="328"/>
+        <location filename="../ui/mainwindow.ui" line="331"/>
         <source>Toolbar</source>
         <translation>Панель інструментів</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="741"/>
+        <location filename="../src/mainwindow.cpp" line="757"/>
         <source>P&amp;rint Preview...</source>
         <translation>&amp;Попередній перегляд...</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="743"/>
+        <location filename="../src/mainwindow.cpp" line="759"/>
         <source>Preview solution results</source>
         <translation>Попередній перегляд результатів розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="746"/>
+        <location filename="../src/mainwindow.cpp" line="762"/>
         <source>Preview current solution results before printing</source>
         <translation>Попередній перегляд результатів розв&apos;язку перед друком</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="749"/>
+        <location filename="../src/mainwindow.cpp" line="765"/>
         <source>&amp;Print...</source>
         <translation>&amp;Друк...</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="751"/>
+        <location filename="../src/mainwindow.cpp" line="767"/>
         <source>Print solution</source>
         <translation>Друк розв&apos;зку</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="754"/>
+        <location filename="../src/mainwindow.cpp" line="770"/>
         <source>Print current solution results</source>
         <translation>Роздрукувати поточний результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="756"/>
+        <location filename="../src/mainwindow.cpp" line="772"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="349"/>
+        <location filename="../ui/mainwindow.ui" line="352"/>
         <source>&amp;Solution...</source>
         <translation>&amp;Розв&apos;язок...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="488"/>
+        <location filename="../ui/mainwindow.ui" line="491"/>
         <source>Detect language automatically</source>
         <translation>Визначати мову автоматично</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="491"/>
+        <location filename="../ui/mainwindow.ui" line="494"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Визначати мову автоматично, використовуючи регіональні стандарти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="523"/>
+        <location filename="../ui/mainwindow.ui" line="526"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="373"/>
+        <location filename="../ui/mainwindow.ui" line="376"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="24"/>
+        <location filename="../ui/mainwindow.ui" line="27"/>
         <source>Task</source>
         <translation>Умова</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="45"/>
+        <location filename="../ui/mainwindow.ui" line="48"/>
         <source>&amp;Variant:</source>
         <translation>&amp;Варіант:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="68"/>
+        <location filename="../ui/mainwindow.ui" line="71"/>
         <source>&amp;Cities:</source>
         <translation>&amp;Міст:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="109"/>
+        <location filename="../ui/mainwindow.ui" line="112"/>
         <source>Cost of travel from city to city</source>
         <translation>Вартість переїзду з міста у місто</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="137"/>
+        <location filename="../ui/mainwindow.ui" line="140"/>
         <source>Fill table with random numbers</source>
         <translation>Заповнити таблицю випадковими значеннями</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="140"/>
+        <location filename="../ui/mainwindow.ui" line="143"/>
         <source>Random</source>
         <translation>Випадково</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="154"/>
+        <location filename="../ui/mainwindow.ui" line="157"/>
         <source>Solve current task</source>
         <translation>Розв&apos;язати поточну задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="157"/>
+        <location filename="../ui/mainwindow.ui" line="160"/>
         <source>Solve</source>
         <translation>Розв&apos;язати</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="171"/>
+        <location filename="../ui/mainwindow.ui" line="174"/>
         <source>Solution</source>
         <translation>Розв&apos;язок</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="180"/>
+        <location filename="../ui/mainwindow.ui" line="183"/>
         <source>Solution steps</source>
         <translation>Хід розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="201"/>
-        <location filename="../ui/mainwindow.ui" line="355"/>
+        <location filename="../ui/mainwindow.ui" line="204"/>
+        <location filename="../ui/mainwindow.ui" line="358"/>
         <source>Save solution to a file</source>
         <translation>Зберегти розв&apos;язок у файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="204"/>
+        <location filename="../ui/mainwindow.ui" line="207"/>
         <source>Save Solution</source>
         <translation>Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="231"/>
+        <location filename="../ui/mainwindow.ui" line="234"/>
         <source>Go back to Task tab</source>
         <translation>Повернутися до закладки &quot;Умова&quot;</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="234"/>
+        <location filename="../ui/mainwindow.ui" line="237"/>
         <source>Back to Task</source>
         <translation>До умови</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="263"/>
+        <location filename="../ui/mainwindow.ui" line="266"/>
         <source>&amp;File</source>
         <translation>&amp;Файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="295"/>
+        <location filename="../ui/mainwindow.ui" line="298"/>
         <source>&amp;Language</source>
         <comment>Please, append &quot; / Language&quot; when translating this string.</comment>
@@ -336,151 +336,151 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="433"/>
+        <location filename="../ui/mainwindow.ui" line="436"/>
         <source>Context &amp;Help</source>
         <translation>&amp;Контекстна допомога</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="448"/>
+        <location filename="../ui/mainwindow.ui" line="451"/>
         <source>&amp;About TSPSG...</source>
         <translation>&amp;Про TSPSG...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="514"/>
+        <location filename="../ui/mainwindow.ui" line="517"/>
         <source>&amp;Save</source>
         <translation>&amp;Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="285"/>
+        <location filename="../ui/mainwindow.ui" line="288"/>
         <source>&amp;Settings</source>
-        <translation>&amp;Налагодження</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="311"/>
+        <translation>&amp;Налаштування</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="314"/>
         <source>&amp;Help</source>
         <translation>&amp;Допомога</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="352"/>
+        <location filename="../ui/mainwindow.ui" line="355"/>
         <source>Save solution</source>
         <translation>Зберегти розв&apos;язок</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="364"/>
+        <location filename="../ui/mainwindow.ui" line="367"/>
         <source>&amp;New</source>
         <translation>&amp;Створити</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="367"/>
+        <location filename="../ui/mainwindow.ui" line="370"/>
         <source>New task</source>
         <translation>Нова задача</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="370"/>
+        <location filename="../ui/mainwindow.ui" line="373"/>
         <source>Create new task</source>
         <translation>Створити нову задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="382"/>
+        <location filename="../ui/mainwindow.ui" line="385"/>
         <source>&amp;Open...</source>
         <translation>&amp;Відкрити...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="385"/>
+        <location filename="../ui/mainwindow.ui" line="388"/>
         <source>Open task</source>
         <translation>Відкрити умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="388"/>
+        <location filename="../ui/mainwindow.ui" line="391"/>
         <source>Open saved task</source>
         <translation>Відкрити збережену умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="391"/>
+        <location filename="../ui/mainwindow.ui" line="394"/>
         <source>Ctrl+O</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="400"/>
+        <location filename="../ui/mainwindow.ui" line="403"/>
         <source>&amp;Preferences...</source>
         <translation>&amp;Параметри...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="403"/>
+        <location filename="../ui/mainwindow.ui" line="406"/>
         <source>Application preferences</source>
         <translation>Параметри додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="415"/>
+        <location filename="../ui/mainwindow.ui" line="418"/>
         <source>&amp;Contents</source>
         <translation>&amp;Зміст</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="418"/>
+        <location filename="../ui/mainwindow.ui" line="421"/>
         <source>Open help contents</source>
         <translation>Відкрити зміст допомоги</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="421"/>
+        <location filename="../ui/mainwindow.ui" line="424"/>
         <source>Ctrl+F1</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="436"/>
+        <location filename="../ui/mainwindow.ui" line="439"/>
         <source>Open context help</source>
         <translation>Відкрити контекстну допомогу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="439"/>
+        <location filename="../ui/mainwindow.ui" line="442"/>
         <source>F1</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="451"/>
+        <location filename="../ui/mainwindow.ui" line="454"/>
         <source>About application</source>
         <translation>Про додаток</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="460"/>
+        <location filename="../ui/mainwindow.ui" line="463"/>
         <source>E&amp;xit</source>
         <translation>В&amp;ихід</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="463"/>
+        <location filename="../ui/mainwindow.ui" line="466"/>
         <source>Exit application</source>
         <translation>Вийти з додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="468"/>
+        <location filename="../ui/mainwindow.ui" line="471"/>
         <source>&amp;Task...</source>
         <translation>&amp;Умову...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="471"/>
-        <location filename="../ui/mainwindow.ui" line="517"/>
+        <location filename="../ui/mainwindow.ui" line="474"/>
+        <location filename="../ui/mainwindow.ui" line="520"/>
         <source>Save task</source>
         <translation>Зберегти умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="474"/>
+        <location filename="../ui/mainwindow.ui" line="477"/>
         <source>Save task to file</source>
         <translation>Зберегти умову задачі у файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="485"/>
+        <location filename="../ui/mainwindow.ui" line="488"/>
         <source>&amp;Autodetect</source>
         <translation>&amp;Автовизначення</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="520"/>
+        <location filename="../ui/mainwindow.ui" line="523"/>
         <source>Save current task</source>
         <translation>Зберегти поточну умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="532"/>
+        <location filename="../ui/mainwindow.ui" line="535"/>
         <source>About &amp;Qt...</source>
         <translation>Про &amp;Qt...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="535"/>
+        <location filename="../ui/mainwindow.ui" line="538"/>
         <source>About Qt library</source>
         <translation>Про бібліотеку Qt</translation>
@@ -493,44 +493,40 @@
     </message>
     <message>
-        <source>Unable to load translation language.</source>
-        <translation type="obsolete">Неможливо завантажити переклад.</translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ui" line="15"/>
-        <location filename="../src/mainwindow.cpp" line="785"/>
+        <location filename="../src/mainwindow.cpp" line="801"/>
         <source>Travelling Salesman Problem</source>
         <translation>Задача комівояжера</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="677"/>
+        <location filename="../src/mainwindow.cpp" line="693"/>
         <source>Unsaved Changes</source>
         <translation>Незбережені зміни</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="132"/>
+        <location filename="../src/mainwindow.cpp" line="131"/>
         <source>All Supported Formats</source>
         <translation>Усі підтримувані формати</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="135"/>
+        <location filename="../src/mainwindow.cpp" line="134"/>
         <location filename="../src/mainwindow.cpp" line="191"/>
-        <location filename="../src/mainwindow.cpp" line="762"/>
+        <location filename="../src/mainwindow.cpp" line="778"/>
         <source>All Files</source>
         <translation>Усі файли</translation>
     </message>
     <message>
+        <location filename="../src/mainwindow.cpp" line="132"/>
         <location filename="../src/mainwindow.cpp" line="133"/>
-        <location filename="../src/mainwindow.cpp" line="134"/>
         <source>%1 Task Files</source>
         <translation>Файли умов %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="664"/>
-        <location filename="../src/mainwindow.cpp" line="666"/>
+        <location filename="../src/mainwindow.cpp" line="680"/>
+        <location filename="../src/mainwindow.cpp" line="682"/>
         <source>Language Change</source>
         <translation>Зміна мови</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="677"/>
+        <location filename="../src/mainwindow.cpp" line="693"/>
         <source>Would you like to save changes in current task?</source>
         <translation>Бажаете зберегти зміни у поточній задачі?</translation>
@@ -552,16 +548,16 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="436"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Selected candidate for branching: %1.</source>
         <translation>Обраний кандидат на розгалудження: %1.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="436"/>
-        <location filename="../src/mainwindow.cpp" line="443"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
+        <location filename="../src/mainwindow.cpp" line="445"/>
         <source>(%1;%2)</source>
         <translation></translation>
     </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="445"/>
+        <location filename="../src/mainwindow.cpp" line="447"/>
         <source>%n alternate candidate(s) for branching: %1.</source>
         <translation>
@@ -572,5 +568,5 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="463"/>
+        <location filename="../src/mainwindow.cpp" line="465"/>
         <source>The price is &lt;b&gt;%n&lt;/b&gt; unit(s).</source>
         <translation>
@@ -581,5 +577,5 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="761"/>
+        <location filename="../src/mainwindow.cpp" line="777"/>
         <source>%1 Task File</source>
         <translation>Файл умови %1</translation>
@@ -591,5 +587,5 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="138"/>
+        <location filename="../src/mainwindow.cpp" line="137"/>
         <source>Task Load</source>
         <translation>Завантаження умови</translation>
@@ -608,57 +604,57 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="409"/>
+        <location filename="../src/mainwindow.cpp" line="411"/>
         <source>Data error</source>
         <translation>Помилка у даних</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="409"/>
+        <location filename="../src/mainwindow.cpp" line="411"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="422"/>
+        <location filename="../src/mainwindow.cpp" line="424"/>
         <source>Variant #%1</source>
         <translation>Варіант №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="423"/>
+        <location filename="../src/mainwindow.cpp" line="425"/>
         <source>Task:</source>
         <translation>Умова:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="426"/>
-        <location filename="../src/mainwindow.cpp" line="473"/>
+        <location filename="../src/mainwindow.cpp" line="428"/>
+        <location filename="../src/mainwindow.cpp" line="475"/>
         <source>Solution of Variant #%1 task</source>
         <translation>Розв&apos;язок варіанту №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="432"/>
+        <location filename="../src/mainwindow.cpp" line="434"/>
         <source>Step #%1</source>
         <translation>Крок №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="458"/>
+        <location filename="../src/mainwindow.cpp" line="460"/>
         <source>Optimal path:</source>
         <translation>Оптимальний шлях:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="460"/>
+        <location filename="../src/mainwindow.cpp" line="462"/>
         <source>Resulting path:</source>
         <translation>Знайдений шлях:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="465"/>
+        <location filename="../src/mainwindow.cpp" line="467"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation>Вартість - &lt;b&gt;%1&lt;/b&gt; одиниць.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="468"/>
+        <location filename="../src/mainwindow.cpp" line="470"/>
         <source>&lt;b&gt;WARNING!!!&lt;/b&gt;&lt;br&gt;This result is a record, but it may not be optimal.&lt;br&gt;Iterations need to be continued to check whether this result is optimal or get an optimal one.</source>
         <translation>&lt;b&gt;Увага!!!&lt;/b&gt;&lt;br&gt;Знайдений розв&apos;язок є рекордом, але може бути неоптимальним.&lt;br&gt;Для отримання оптимального розв&apos;зку, або перевірки поточного на оптимальність, потрібно продовжити ітерації.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="664"/>
-        <location filename="../src/mainwindow.cpp" line="666"/>
+        <location filename="../src/mainwindow.cpp" line="680"/>
+        <location filename="../src/mainwindow.cpp" line="682"/>
         <source>Unable to load the translation language.
 Falling back to autodetection.</source>
@@ -667,10 +663,10 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="738"/>
+        <location filename="../src/mainwindow.cpp" line="754"/>
         <source>Set application language to %1</source>
         <translation>Змінити мову додатку на %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="770"/>
+        <location filename="../src/mainwindow.cpp" line="786"/>
         <source>Task Save</source>
         <translation>Збереження умови</translation>
@@ -691,8 +687,9 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.h" line="106"/>
+        <location filename="../src/mainwindow.cpp" line="151"/>
         <location filename="../src/mainwindow.cpp" line="152"/>
         <location filename="../src/mainwindow.cpp" line="168"/>
         <location filename="../src/mainwindow.cpp" line="290"/>
+        <location filename="../src/mainwindow.h" line="107"/>
         <source>Untitled</source>
         <translation>Без імені</translation>
@@ -702,186 +699,213 @@
     <name>SettingsDialog</name>
     <message>
-        <location filename="../src/settingsdialog.cpp" line="80"/>
+        <location filename="../src/settingsdialog.cpp" line="83"/>
         <source>Use translucent effect on the Main Window under Windows Vista and 7</source>
-        <translation>Використовувати ефект полупрозорості для головного вікна у Windows Vista та 7</translation>
-    </message>
-    <message>
-        <location filename="../src/settingsdialog.cpp" line="82"/>
+        <translation>Використовувати ефект полупрозорості для головного вікна у Windows Vista та Windows 7</translation>
+    </message>
+    <message>
+        <location filename="../src/settingsdialog.cpp" line="85"/>
         <source>Use translucency effects</source>
         <translation>Використовувати ефекти напівпрозорості</translation>
     </message>
     <message>
-        <location filename="../src/settingsdialog.cpp" line="89"/>
+        <location filename="../src/settingsdialog.cpp" line="93"/>
         <source>Restore main window state and position on application restart</source>
         <translation>Відновлювати стан та розмір головного вікна після перезапуску</translation>
     </message>
     <message>
-        <location filename="../src/settingsdialog.cpp" line="91"/>
+        <location filename="../src/settingsdialog.cpp" line="95"/>
         <source>Save main window state and position</source>
-        <translation>Зберігати стан та розміщення
-головного вікна</translation>
-    </message>
-    <message>
-        <location filename="../src/settingsdialog.cpp" line="113"/>
+        <translation>Зберігати стан та розміщення головного вікна</translation>
+    </message>
+    <message>
+        <location filename="../src/settingsdialog.cpp" line="117"/>
         <source>Hover mouse pointer over dialog elements to get additional help</source>
         <translation>Наведіть покажчик миші на елемент ділогу, щоб отримати підказку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="15"/>
+        <location filename="../src/settingsdialog.cpp" line="239"/>
+        <location filename="../src/settingsdialog.cpp" line="245"/>
+        <source>Settings Reset</source>
+        <translation>Скидання налагоджень</translation>
+    </message>
+    <message>
+        <location filename="../src/settingsdialog.cpp" line="239"/>
+        <source>Do you really want to &lt;b&gt;reset all application settings to their defaults&lt;/b&gt;?</source>
+        <translation>Ви дісно хочете &lt;b&gt;скинути усі налаштування на значення по-замовчуванню&lt;/b&gt;?</translation>
+    </message>
+    <message>
+        <location filename="../src/settingsdialog.cpp" line="245"/>
+        <source>All settings where successfully reset to their defaults.
+It is recommended to restart the application now.</source>
+        <translation>Усі налаштування було успішно скинуто на значення по-замовчуванню.
+Рекомендується перезапустити додаток.</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="7"/>
         <source>Preferences</source>
         <translation>Параметри</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="237"/>
+        <location filename="../ui/settingsdialog.ui" line="226"/>
         <source>Task</source>
         <translation>Задача</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="240"/>
+        <location filename="../ui/settingsdialog.ui" line="229"/>
         <source>Task generation and solving settings</source>
         <translation>Налаштування генерації та розв&apos;язку задач</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="248"/>
+        <location filename="../ui/settingsdialog.ui" line="240"/>
         <source>Fractional accuracy:</source>
         <translation>Точність дробових чисел:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="258"/>
+        <location filename="../ui/settingsdialog.ui" line="250"/>
         <source>Accuracy of the fractional values (in decimal places)</source>
         <translation>Точність дробових чисел (у знаках після коми)</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="285"/>
-        <source>Random numbers</source>
-        <translation>Випадкові числа</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="296"/>
-        <source>&amp;Minimal:</source>
-        <translation>&amp;Мінімум:</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="309"/>
+        <location filename="../ui/settingsdialog.ui" line="299"/>
         <source>Minimum for random number generation</source>
         <translation>Нажня межа для генерації випадкових значень</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="316"/>
-        <source>Ma&amp;ximal:</source>
-        <translation>М&amp;аксимум:</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="329"/>
+        <location filename="../ui/settingsdialog.ui" line="319"/>
         <source>Maximum for random number generation</source>
         <translation>Верхня межа для генерації випадкових значень</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="341"/>
+        <location filename="../ui/settingsdialog.ui" line="331"/>
         <source>Generate fractional random values with the Fractional accuracy</source>
         <translation>Генерувати дробові випадкові числа з вказаною вище точністю</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="482"/>
+        <location filename="../ui/settingsdialog.ui" line="457"/>
         <source>Output font settings</source>
         <translation>Параметри шрифта</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="511"/>
+        <location filename="../ui/settingsdialog.ui" line="486"/>
         <source>&amp;Color...</source>
         <translation>&amp;Колір...</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="200"/>
+        <location filename="../ui/settingsdialog.ui" line="189"/>
         <source>Automatically resize rows and columns to their contents</source>
         <translation>Автоматично підганяти розмір рядків під їх зміст</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="188"/>
+        <location filename="../ui/settingsdialog.ui" line="177"/>
         <source>General</source>
         <translation>Загальні</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="191"/>
+        <location filename="../ui/settingsdialog.ui" line="180"/>
         <source>General TSPSG settings</source>
         <translation>Загальні налаштування TSPSG</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="203"/>
+        <location filename="../ui/settingsdialog.ui" line="192"/>
         <source>Autosize of rows and columns</source>
         <translation>Авторозмір рядків та колонок</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="213"/>
+        <location filename="../ui/settingsdialog.ui" line="202"/>
         <source>Use native File Open and File Save dialogs (uncheck to use Qt&apos;s Dialogs)</source>
         <translation>Використовувати системні діалоги відкриття та збереження файлу</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="383"/>
+        <location filename="../ui/settingsdialog.ui" line="275"/>
+        <source>Task generation</source>
+        <translation>Генерація задач</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="358"/>
         <source>Output</source>
         <translation>Виведення</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="386"/>
+        <location filename="../ui/settingsdialog.ui" line="361"/>
         <source>Solution output settings</source>
         <translation>Налаштування виводу розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="395"/>
+        <location filename="../ui/settingsdialog.ui" line="370"/>
         <source>Show solution steps&apos; matrices for every solution step</source>
         <translation>Показувати матриці кроків розв&apos;язку для кожного кроку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="398"/>
+        <location filename="../ui/settingsdialog.ui" line="373"/>
         <source>Show solution steps&apos; matrices</source>
         <translation>Показ матриць кроків розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="429"/>
+        <location filename="../ui/settingsdialog.ui" line="404"/>
         <source>Show or hide solution steps&apos; matrices based on number of cities in the task</source>
         <translation>Показувати матриці ходу розв&apos;язку в залежності від кількості міст</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="439"/>
+        <location filename="../ui/settingsdialog.ui" line="414"/>
         <source>Maximum number of cities to show solution steps&apos; matrices</source>
         <translation>Максимальна кількість міст для показу матриць кроків розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="491"/>
+        <location filename="../ui/settingsdialog.ui" line="466"/>
         <source>Font face for solution output</source>
         <translation>Вигляд шрифта для виводу</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="508"/>
+        <location filename="../ui/settingsdialog.ui" line="483"/>
         <source>Font color for solution output</source>
         <translation>Колір шрифта для виводу</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="344"/>
+        <location filename="../ui/settingsdialog.ui" line="334"/>
         <source>Fractional random values</source>
         <translation>Дробові випадкові числа</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="470"/>
+        <location filename="../ui/settingsdialog.ui" line="445"/>
         <source>Scroll to the end of solution output after solving</source>
         <translation>Прокручувати в кінець виводу після закінчення розв&apos;язку задачі</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="473"/>
+        <location filename="../ui/settingsdialog.ui" line="448"/>
         <source>Scroll to solution end</source>
         <translation>Прокручувати в кінець розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="216"/>
+        <location filename="../ui/settingsdialog.ui" line="205"/>
         <source>Use native file dialogs</source>
         <translation>Системні файлові діалоги</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="432"/>
+        <location filename="../ui/settingsdialog.ui" line="265"/>
+        <source>In this mode the cost of travel from city 1 to city 2 and vice versa is the same</source>
+        <translation>У цьому режимі вартість переїзду з міста 1 у місто 2 та навпаки співпадає</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="268"/>
+        <source>Symmetric mode</source>
+        <translation>Симетричний режим</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="286"/>
+        <source>Minimal random:</source>
+        <translation>Мінімальне випадкове:</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="306"/>
+        <source>Maximal random:</source>
+        <translation>Максимальне випадкове:</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="407"/>
         <source>Only when &lt;=</source>
         <translation>Лише коли ≤</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="442"/>
+        <location filename="../ui/settingsdialog.ui" line="417"/>
         <source> cities</source>
         <comment>Don&apos;t forget a space at the beginning!</comment>
@@ -889,16 +913,16 @@
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="494"/>
+        <location filename="../ui/settingsdialog.ui" line="469"/>
         <source>&amp;Font...</source>
         <translation>&amp;Шрифт...</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="111"/>
-        <location filename="../ui/settingsdialog.ui" line="117"/>
+        <location filename="../ui/settingsdialog.ui" line="103"/>
+        <location filename="../ui/settingsdialog.ui" line="109"/>
         <source>Help</source>
         <translation>Допомога</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="114"/>
+        <location filename="../ui/settingsdialog.ui" line="106"/>
         <source>Get preferences help</source>
         <translation>Отримати допомогу по налагодженням</translation>
